/*
 * Params: none
 */
lm.component('lmDialogUserCreate', {
	templateUrl: 'comp/dialog/lmDialogUserCreate.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.availableAuthorities = lmBase.authorities;
		ctrl.availableLanguages = [];
		
		ctrl.item = {name: '', password: '', language: null, authorities: []};
		lmBase.multiSelectionInit(ctrl.item.authorities,ctrl.availableAuthorities,['ROLE_WRITE']);

		ctrl.$onInit = function() {
			/* load available languages */
			$http.get(lmBase.url + 'system/info').then(
				function success(resp) {
					ctrl.availableLanguages = resp.data.languages;
					ctrl.item.language = resp.data.languages[0].code;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.ok = function() {
			var req = {name: ctrl.item.name, password: ctrl.item.password, language: ctrl.item.language}
			req.authorities = lmBase.multiSelectionGetSelected(ctrl.item.authorities);
			
			$http.post(lmBase.url + 'userAdmin/user',req).then(
				function success(resp) {
					ctrl.lmDone();
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};	
	
	}
});
