lm.component('noteList', {
  templateUrl: 'comp/misc/noteList.' + lmCacheTag + 'html',
  bindings: {
	  label: '<',
	  search: '<'
  },
  controller: function($scope, $http, serviceLimboMedia, serviceModal) {
	  var ctrl = this;
	  
	  ctrl.items = [];
	  
	  /* paging and sorting */
	  ctrl.ps = {fr: 0, hasMore: false, predicate: 'NAME', dir: 'asc'};
	  
	  ctrl.changeOrder = function(valueOrder) {
		  if(ctrl.ps.predicate == valueOrder) {
				ctrl.ps.dir = ctrl.ps.dir == 'asc' ? 'desc' : 'asc';
			}
			else {
				ctrl.ps.dir = 'asc';
				ctrl.ps.predicate = valueOrder;
			}
			ctrl.loadItems();
		};	  
	  
	  /* loading */
	  ctrl.loadItems = function() {
		  var par = {fr: 0, mr: 0, order: ctrl.ps.predicate, dir: ctrl.ps.dir};

		  if(ctrl.search && ctrl.search.active) {
				par.s = ctrl.search.value;
				$http.get(lmBase.url + 'n/items/search',{params : par}).then(
					function success(resp) {
						ctrl.items = resp.data;
					},
					serviceLimboMedia.handleHttpErrorNew
				);
		  }
		  else if(ctrl.label) {
				par.lid = ctrl.label.id;
				$http.get(lmBase.url + 'n/items/list',{params : par}).then(
					function success(resp) {
						ctrl.items = resp.data;
					},
					serviceLimboMedia.handleHttpErrorNew
				);
		  }
		  else {
			  ctrl.items = [];
		  }
	  };
	  
	  /* items */
	  ctrl.itemCreateName = '';
	  ctrl.itemCreateContent = '';
	  ctrl.itemCreate = function() {
			var req = {name: ctrl.itemCreateName, content: ctrl.itemCreateContent, labelId: ctrl.label.id};
			$http.post(lmBase.url + 'n/item',req).then(
				function success(resp) {
					ctrl.itemCreateName = '';
					ctrl.itemCreateContent = '';
					ctrl.loadItems();
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};
		
		ctrl.itemDelete = function(valueItem) {
			$http.delete(lmBase.url + 'n/item/' + valueItem.id).then(
				function success(resp) {
					var idx = ctrl.items.indexOf(valueItem);
					ctrl.items.splice(idx,1);
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.itemEdit = function(valueItem) {
			serviceModal.show('lm-dialog-note-edit',{id: valueItem.id}).then(
				  function() { ctrl.loadItems(); },
				  function() {}
			);
		};
		
		ctrl.itemSave = function(valueItem) {
			var req = {name: valueItem.name, content: valueItem.content, labelId: valueItem.label.id};
			$http.post(lmBase.url + 'n/item/' + valueItem.id,req).then(
				function success(resp) {
					valueItem.show = false;
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};

		/* settings */
	  ctrl.settings = new Object();
			
	  ctrl.toggleConfig = function() {
		  serviceModal.show('lm-dialog-note-settings').then(function() {}, function() {});
	  };
		
	  /* init */
	  ctrl.$onInit = function() {
		  $scope.$watch('$ctrl.label', function(someValue) {
			  ctrl.loadItems();
		  });

		  $scope.$watch('$ctrl.search.active', function(someValue) {
			  ctrl.loadItems();
		  });

		  ctrl.settings = serviceLimboMedia.getRemoteSettings('notes');
		  if(ctrl.settings.colName == null) ctrl.settings.colName = true;
		  if(ctrl.settings.colAdded == null) ctrl.settings.colAdded = false;
	  };
	  
  }

});