lm.component('sidebarLabel', {
  templateUrl: 'comp/misc/sidebarLabel.' + lmCacheTag + 'html',
  bindings: {
	  prefix: '<',
	  onItemSelect: '&'
  },
  controller: function($http, serviceLimboMedia, serviceModal) {
	  var ctrl = this;
	  
	  ctrl.item = null;
	  ctrl.items = [];
	  
	  ctrl.userdetails = serviceLimboMedia.getUserdetails();
	  
	  ctrl.loadItems = function() {
		  $http.get(lmBase.url + ctrl.prefix + '/labels/all').then(
				  function success(resp) {
					  ctrl.items = resp.data;
		  		
					  if(ctrl.items.length > 0) {
						  ctrl.selectItem(ctrl.items[0]);
					  }
				  },
				  serviceLimboMedia.handleHttpErrorNew
				 );
	  };

	  ctrl.selectItem = function(valueItem) {
		  if(ctrl.item != null) {
			  if(ctrl.item == valueItem) return;
			  ctrl.item.classActive = '';
		  }
		  ctrl.item = valueItem;
		  ctrl.item.classActive = 'active';
		  ctrl.onItemSelect({selectedItem: ctrl.item});
	  }

	  ctrl.selectItemSelectSelectbox = function() {
		  for(x in ctrl.items) {
			  ctrl.items[x].classActive = '';
		  }
		  ctrl.item.classActive = 'active';
		  ctrl.onItemSelect({selectedItem: ctrl.item});
	  }
	  
	  ctrl.createItemName = '';
	  ctrl.createItem = function() {
		  $http.post(lmBase.url + ctrl.prefix + '/label',{name: ctrl.createItemName}).then(
		  		function success(resp) {
		  			ctrl.createItemName = '';
		  			ctrl.loadItems();
		  		},
		  		serviceLimboMedia.handleHttpErrorNew
		  	);		
	  }
	  
	  
	  ctrl.itemDelete = function(valueItem) {
		  serviceModal.show('lm-dialog-delete',{url: lmBase.url + ctrl.prefix + '/label/' + valueItem.id, name: valueItem.name}).then(
			  function() { ctrl.loadItems(); },
			  function() {}
		  );
	  };
	  
	  ctrl.itemEdit = function(valueLabel) {
			serviceModal.show('lm-dialog-rename',{name: valueLabel.name, url: lmBase.url + ctrl.prefix + '/label/' + valueLabel.id}).then(
				  function() { ctrl.loadItems(); },
				  function() {}
			);
	  };	
		
		ctrl.itemShare = function(valueItem) {
			serviceModal.show('lm-dialog-share',{user: valueItem.x.user, url: lmBase.url + ctrl.prefix + '/label/' + valueItem.id + '/shares'}).then(
				  function() { ctrl.loadItems(); },
				  function() { }
			);
		};	  
		
	  ctrl.$onInit = function() {
		  ctrl.loadItems();
	  };
	  
  }
});