lm.component('todoBox', {
	templateUrl: 'comp/misc/todoBox.' + lmCacheTag + 'html',
	bindings: {
		item: '<',
		afterChange: '&'
	},
	controller: function($http, serviceLimboMedia, serviceModal) {
		var ctrl = this;
	  
		ctrl.userdetails = serviceLimboMedia.getUserdetails();
		ctrl.itemCreateName = '';

		/* label stuff */
		ctrl.labelDelete = function(valueLabel) {
			serviceModal.show('lm-dialog-delete',{url: lmBase.url + 't/label/' + valueLabel.id, name: valueLabel.name}).then(
				  function() { ctrl.afterChange(ctrl.item); },
				  function() {}
			);
		};
		
		ctrl.labelEdit = function(valueLabel) {
			serviceModal.show('lm-dialog-rename',{name: valueLabel.name, url: lmBase.url + 't/label/' + valueLabel.id}).then(
				  function() { ctrl.labelReload(); },
				  function() {}
			);
		};
		
		ctrl.labelShare = function(valueLabel) {
			serviceModal.show('lm-dialog-share',{user: valueLabel.x.user, url: lmBase.url + 't/label/' + valueLabel.id + '/shares'}).then(
				  function() { ctrl.labelReload(); },
				  function() { }
			);
		};
		
		ctrl.labelReload = function() {
			$http.get(lmBase.url + 't/label/' + ctrl.item.label.id).then(
				function success(resp) {
					ctrl.item.label = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		/* item stuff */
		ctrl.itemToggle = function(valueItem) {
			$http.post(lmBase.url + 't/item/' + valueItem.id + '/toggle',valueItem.done).then(
				function success(resp) {},
				function error(resp) {
					valueItem.done = !valueItem.done;
					serviceLimboMedia.handleHttpErrorNew(resp);	
				}
				
			);		
		};
		
		ctrl.itemDelete = function(valueItem) {
			$http.delete(lmBase.url + 't/item/' + valueItem.id).then(
				function success(resp) {
					var idx = ctrl.item.items.indexOf(valueItem);
					ctrl.item.items.splice(idx,1);
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.itemEdit = function(valueItem) {
			serviceModal.show('lm-dialog-todo-edit',{id: valueItem.id}).then(
				  function() { ctrl.afterChange(ctrl.item); },
				  function() {}
			);
		};
		
		ctrl.itemCreate = function() {
			$http.post(lmBase.url + 't/item',{name: ctrl.itemCreateName, labelId: ctrl.item.label.id}).then(
				function success(resp) {
					ctrl.itemCreateName = '';
					ctrl.itemsReload();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};		
		
		ctrl.itemsReload = function() {
			$http.get(lmBase.url + 't/items/list',{params : {lid: ctrl.item.label.id}}).then(
				function success(resp) {
					ctrl.item.items = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
	}
});