lm.component('todoList', {
	templateUrl: 'comp/misc/todoList.' + lmCacheTag + 'html',
	bindings: {
		items: '<',
		onReload: '&',
		title: '@'
	},
	controller: function($http, serviceLimboMedia, serviceModal) {
		var ctrl = this;
	  
		ctrl.userdetails = serviceLimboMedia.getUserdetails();
		
		ctrl.itemToggle = function(valueItem) {
			$http.post(lmBase.url + 't/item/' + valueItem.id + '/toggle',!valueItem.done).then(
				function success(resp) {},
				function error(resp) {
					valueItem.done = !valueItem.done;
					serviceLimboMedia.handleHttpErrorNew(resp);
				}
			);		
		};
		
		ctrl.itemDelete = function(valueItem) {
			$http.delete(lmBase.url + 't/item/' + valueItem.id).then(
				function success(resp) {
					var idx = ctrl.items.indexOf(valueItem);
					ctrl.items.splice(idx,1);
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.itemEdit = function(valueItem) {
			serviceModal.show('lm-dialog-todo-edit',{id: valueItem.id}).then(
				  function() { ctrl.onReload(); },
				  function() {}
			);
		};		
		
	}
});