lm.component('pageSysStats', {
  templateUrl: 'comp/page_sys/pageSysStats.' + lmCacheTag + 'html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, serviceLimboMedia) {
	  var ctrl = this;
	  
	  ctrl.users = [];
		
	  ctrl.toggleDetails = function(valUser) {
			valUser.showDetails = (valUser.showDetails == null) ? "yes" : null;
	  };
		
	  ctrl.loadUsers = function() {
			$http.get(lmBase.url + 'user/users').then(
				function success(resp) {
					ctrl.users = resp.data;
					for(y in ctrl.users) {
						ctrl.loadStats(ctrl.users[y]);
					}
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};	
		
		ctrl.loadStats = function(usr) {
			ctrl.formats = null;
			ctrl.stats = null;
			ctrl.overall = null;

			$http.get(lmBase.url + 'stats/stats/' + usr.id,{target: usr}).then(
				function success(resp) {
					var overall = new Object();
					overall.size = 0;
					overall.items = 0;
					
					for(x in resp.data) {
						var dat = resp.data[x];
						dat.hasDetails = false;
						overall.size += dat.sizeSum;
						overall.items += dat.count;
					}
					resp.config.target.stats = resp.data;
					resp.config.target.overall = overall;
				},
				serviceLimboMedia.handleHttpErrorNew
			);	
		};
		
		  
		
		ctrl.$onInit = function() {
			
			ctrl.loadUsers();
		};
  }
});