lm.component('pageSetUser', {
	templateUrl: 'comp/page_usr/pageSetUser.' + lmCacheTag + 'html',
	bindings: {},
	$canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
		return serviceLimboMedia.isAuthenticated();
	},
	controller: function($scope, $http, serviceLimboMedia, serviceNotification, serviceUpload) {
		var ctrl = this;
	  
		/* user details */
		ctrl.user = serviceLimboMedia.userdetails.user;

		/* password change */
		ctrl.pwchange = {old: '', neu: ''};
		ctrl.changePassword = function() {
			var req = {passwordOld: ctrl.pwchange.old, passwordNew: ctrl.pwchange.neu};
			$http.post(lmBase.url + 'user/user', req).then(
				function success(resp) {
					serviceNotification.ok('MSG_RELOGIN');
				},
				serviceLimboMedia.handleHttpErrorNew
			);			
		}
	  
		/* settings */
		ctrl.languages = [];
		ctrl.language = ctrl.user.language;
		ctrl.trash = ctrl.user.trash;
  
		ctrl.saveSettings = function() {
			var req = {language: ctrl.language.code, trash: ctrl.trash};
			
			$http.post(lmBase.url + 'user/user', req).then(
				function success(resp) {
					serviceLimboMedia.changeLang(ctrl.language.code);
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		$http.get(lmBase.url + 'system/info').then(
			function success(resp) {
				ctrl.languages = resp.data.languages;
				for(x in resp.data.languages) {
					var it = resp.data.languages[x];
					if(it.code == ctrl.user.language) {
						ctrl.language = it;
					}
				}
			},
			serviceLimboMedia.handleHttpErrorNew
		);		
	}
});