lm.factory('serviceNotification', [ '$timeout', '$translate', 'serviceModal', function($timeout, $translate,serviceModal) {
	var service = new Object();
	service.toasts = [];


	service.toastDone = function(valuee) {
		var idx = service.toasts.indexOf(valuee);
		service.toasts.splice(idx,1);
	}

	service.toastShow = function(valueType, valueStyle, valueKeep, valueData) {
		var newToast = {
				type: valueType ? valueType : 'lm-ui-toast-simple',
				style: valueStyle,
				data: valueData ? valueData : {}
		};
		
		if(!valueKeep) {
			newToast.style += ' ani';
			$timeout(service.toastDone,4000,true,newToast);
		}
		
		service.toasts.push(newToast);
		return newToast;
	};

	service.toastTheError = function(valueText, valueKeep) {
		return service.toastShow(null, 'lm-style-danger', valueKeep, {icon: 'icon-exclamation', text: valueText});
	};

	service.toastTheInfo = function(valueText, valueKeep) {
		return service.toastShow(null, 'lm-style-info', valueKeep, {icon: 'icon-info', text: valueText});
	};

	service.ok = function(msgKey) {
		$translate(msgKey).then(function (translation) {
			service.toastTheInfo(translation);
		});
	};

	service.okParamed = function(msgKey,params) {
		$translate(msgKey).then(function (translation) {
			var msg = translation;
			for(x in params) {
				msg = msg.replace("{" + x + "}", params[x]);
			}
			service.toastTheInfo(msg);
		});
	};
	
	service.error = function(msgKey) {
		$translate(msgKey).then(function (translation) {
			service.toastTheError(translation);
		});
	};
	
	service.errorPlain = function(msg) {
		service.toastTheError(msg);
	};

	service.errorParamed = function(msgKey,params) {
		$translate(msgKey).then(function (translation) {
			var msg = translation;
			for(x in params) {
				msg = msg.replace("{" + x + "}", params[x]);
			}
			service.toastTheError(msg);
		});
	};
	
	service.showWorking = function(promise, i18nMsgKey) {
		serviceModal.show('lm-dialog-working',{msgKey: i18nMsgKey},promise).then(
			  function() {},
			  function() {}
		);
	};
	
	return service;
}]);
